<template>
  <div>
    <div class="row">
      <div class="col-xs-12 col-md-6">
        <el-input
          v-model="search"
          placeholder="Rechercher sur l'email"
        />
      </div>
    </div>
    <div class="row">
      <el-table
        ref="childrenTable"
        :data="pagedAndFilteredChildren"
        :default-sort="{prop: 'createdAt', order: 'descending'}"
        border
        stripe
        style="width: 100%"
        @selection-change="handleSelectionChange"
      >
        <el-table-column
          prop="email"
          label="Email"
        />
        <el-table-column
          prop="name"
          label="Entreprise(s) et groupement(s) autorisé(s)"
        >
          <template slot-scope="scope">
            <p v-if="(scope.row.sirens.length + scope.row.groups.length) > 3">
              <el-button
                type="text"
                @click="seeMore(scope.row.sirens, scope.row.groups)"
              >
                Voir les {{ scope.row.sirens.length + scope.row.groups.length }} éléments
              </el-button>
            </p>
            <div v-else>
              <p
                v-for="(siren, sirenIndex) in scope.row.sirens"
                :key="siren.id"
              >
                {{ scope.row.sirens[sirenIndex].name }}
              </p>
              <p
                v-for="(group, groupIndex) in scope.row.groups"
                :key="group.id"
              >
                {{ scope.row.groups[groupIndex].name }}
              </p>
            </div>
          </template>
        </el-table-column>
        <el-table-column
          prop="address"
          label="Date d'ajout"
        >
          <template slot-scope="scope">
            {{ scope.row.createdAt.date | beautifulDate }}
          </template>
        </el-table-column>
        <el-table-column
          prop="canCreateUser"
          label="Permission de créer des utilisateurs"
        >
          <template slot-scope="scope">
            {{ scope.row.canCreateUser | yesNoText }}
          </template>
        </el-table-column>
        <el-table-column
          prop="canAccessData"
          label="Permission d’accés au tableau de bord"
        >
          <template slot-scope="scope">
            {{ scope.row.canAccessData | yesNoText }}
          </template>
        </el-table-column>
        <el-table-column
          prop="canUploadDsnFile"
          label="Permission d’ajouter des fichiers DSN"
        >
          <template slot-scope="scope">
            {{ scope.row.canUploadDsnFile | yesNoText }}
          </template>
        </el-table-column>
        <el-table-column
          prop="address"
          label="Rôle"
        >
          <template slot-scope="scope">
            {{ scope.row.dsnpRole | dsnRoleLabelFromCode }}
          </template>
        </el-table-column>
        <el-table-column
          prop="edit"
          label=""
        >
          <template slot-scope="scope">
            <click-button
              :disabled="isLoading"
              @click="$router.push({'path':'/utilisateurs/modifier/'+scope.row.id})"
            >
              <template slot="content">
                <edit-icon />
              </template>
            </click-button>
            <click-button
              :disabled="isLoading"
              @click="confirmDeleteChild({child: scope.row,index: scope.$index})"
            >
              <template slot="content">
                <remove-icon />
              </template>
            </click-button>
          </template>
        </el-table-column>
      </el-table>
    </div>
    <div class="row">
      <el-pagination
        :current-page.sync="currentPage"
        :page-size="pageSize"
        layout="total, prev, pager, next"
        :total="filteredChildren.length"
        @current-change="handleCurrentChange"
      />
    </div>
    <confirmation-modal-delete
      id="confirmationModalDelete"
      text="Êtes-vous sûr de vouloir supprimer ce compte utilisateur ?"
      @okClicked="performDeleteChild"
    />
  </div>
</template>

<script>
import {mapActions, mapGetters} from "vuex"
import ClickButton from "../../../components/Button/ClickButton";
import EditIcon from "../../../components/Icon/EditIcon";
import RemoveIcon from "../../../components/Icon/RemoveIcon";
import ConfirmationModalDelete from "../../../components/Modal/ConfirmationModal";
import VanillaToasts from "vanillatoasts";

export default {
  name: "ChildTable",
  components: {RemoveIcon, EditIcon, ClickButton, ConfirmationModalDelete},
  data() {
    return {
      search: '',
      multipleSelection: [],
      currentPage: 1,
      pageSize: 10,
      childAndIndex: null,
    }
  },
  computed: {
    ...mapGetters([
      'children',
      'isLoading',
    ]),
    pagedAndFilteredChildren() {
      return !this.search
        ?
        this.children.slice(this.pageSize * this.currentPage - this.pageSize, this.pageSize * this.currentPage)
        :
        this.filteredChildren.slice(this.pageSize * this.currentPage - this.pageSize, this.pageSize * this.currentPage)
    },
    filteredChildren() {
      return this.search ? this.children.filter(child => (child.email.toLowerCase()).includes(this.search.toLowerCase())) : this.children
    },
  },
  methods: {
    ...mapActions([
      'deleteChild'
    ]),
    confirmDeleteChild(childAndIndex) {
      this.childAndIndex = childAndIndex
      $('#confirmationModalDelete').modal({keyboard:false,backdrop:'static'})
    },
    performDeleteChild() {
      this.deleteChild(this.childAndIndex)
        .then(()=>{
          VanillaToasts.create({
            title: 'Suppression utilisateur',
            text: 'Opération effectuée avec succès',
            type: 'success',
            timeout: 5000,
          });
        })
    },
    seeMore(sirens, groups) {
      let text = ''
      sirens.forEach(siren => {
        text+= siren.name+', '
      })
      groups.forEach(group => {
        text+= group.name+', '
      })
      text = text.substring(0, text.length-2)
      this.$alert(text, 'Entreprise(s) et groupement(s) autorisé(s)', {
        confirmButtonText: 'Retour'
      })
    },
    handleCurrentChange(val) {
      this.currentPage = val
    },
    handleSelectionChange(val) {
      this.multipleSelection = val;
    },
  }
}
</script>

<style scoped>
ul {
  list-style-type: none;
  padding: 15px 0 15px 0;
}
.row {
  margin-top: 2vh;
}
</style>